#!/usr/local/bin/perl
#
#  GPS情報を取得
#

use strict;
use warnings;
use DBI;
use File::Find;
use Encode qw/decode/;
use LWP::Simple qw($ua get);
use JSON;

my $api = "http://maps.googleapis.com/maps/api/geocode/json?address=__q__&sensor=true_or_false";

my ($mday,$mon,$year) = (localtime(time))[3..5];
$year += 1900;
$mon += 1;
my $nowdate = "$year/$mon/$mday";

opendir(DIRHANDLE, "./source");
foreach(readdir(DIRHANDLE)){
	next if /^\.{1,2}$/;	# '.'や'..'をスキップ
	&makeData("$_\n");
}
closedir(DIRHANDLE);

sub makeData {
	if (substr($_[0], 0, 1) eq ".") {return};
	
	# 出力ファイル
	open(DATAFILE, "> ./datas/$_[0]") or die("error :$!");
	print DATAFILE "#Location information	(SnowWeather:$nowdate)\n";

	# 入力ファイル
	print "$_[0]";
	open(INFILE, "< ./source/$_[0]") or die("error :$!");
	while (my $line = <INFILE>){
  		chomp($line);
  		my $url = $api;
  		$url  =~ s/__q__/$line/g;
  		my $res = get($url);
  		if (length($res) > 0) {
	  		my $items = JSON->new()->decode($res);
	  		if(exists($items->{results}[0]->{geometry}->{location}->{lat})) {
	  			my $lat = $items->{results}[0]->{geometry}->{location}->{lat};
	  			my $lng = $items->{results}[0]->{geometry}->{location}->{lng};
	  			print DATAFILE "$line\t$lat\t$lng\n";
	  		}
	  		else {
	  			print DATAFILE "$line\n";
	  			print "$line - not find(1)\n";
	  		}
	  	}
	  	else {
	  		print "$line - not find(0)\n";
	  	}
	  	sleep(1);
	}
	close(INFILE);
	close(DATAFILE);
	print "\n\n";

}